Roll over to a new index
- POST /{alias}/_rollover/{new_index}
- POST /{alias}/_rollover
To automate rollovers, use index lifecycle management (ILM) in deployments that support it. Serverless does not support ILM. For data streams in Serverless, use data stream lifecycle instead.
The rollover API creates a new index for a data stream or index alias. The API behavior depends on the rollover target.
Roll over a data stream
If you roll over a data stream, the API creates a new write index for the stream. The stream's previous write index becomes a regular backing index. A rollover also increments the data stream's generation.
Roll over an index alias with a write index
Prior to Elasticsearch 7.9, you'd typically use an index alias with a write index to manage time series data. Data streams replace this functionality, require less maintenance, and automatically integrate with data tiers.
If an index alias points to multiple indices, one of the indices must be a write index.
The rollover API creates a new write index for the alias with is_write_index set to true.
The API also sets is_write_index to false for the previous write index.
Roll over an index alias with one index
If you roll over an index alias that points to only one index, the API creates a new index for the alias and removes the original index from the alias.
A rollover creates a new index and is subject to the wait_for_active_shards setting.
Increment index names for an alias
When you roll over an index alias, you can specify a name for the new index.
If you don't specify a name and the current index ends with - and a number, such as my-index-000001 or my-index-3, the new index name increments that number.
For example, if you roll over an alias with a current index of my-index-000001, the rollover creates a new index named my-index-000002.
This number is always six characters and zero-padded, regardless of the previous index's name.
If you use an index alias for time series data, you can use date math in the index name to track the rollover date.
For example, you can create an alias that points to an index named <my-index-{now/d}-000001>.
If you create the index on May 6, 2099, the index's name is my-index-2099.05.06-000001.
If you roll over the alias on May 7, 2099, the new index's name is my-index-2099.05.07-000002.
Required privileges
- Index privileges manage
Query parameters
-
dry_runboolean · default: false -
If
true, checks whether the current index satisfies the specified conditions but does not perform a rollover. -
master_timeoutstring · default: 30s -
Period to wait for a connection to the master node. If no response is received before the timeout expires, the request fails and returns an error.
-
timeoutstring · default: 30s -
Period to wait for a response. If no response is received before the timeout expires, the request fails and returns an error.
Request body
-
aliasesmap string to object -
Aliases for the target index. Data streams do not support this parameter.
-
<string>object -
filter{} Query -
Query used to limit documents the alias can access.
-
index_routingstring -
Value used to route indexing operations to a specific shard. If specified, this overwrites the
routingvalue for indexing operations. -
conditionsobject -
Conditions for the rollover. If specified, Elasticsearch only performs the rollover if the current index satisfies these conditions. If this parameter is not specified, Elasticsearch performs the rollover unconditionally. If conditions are specified, at least one of them must be a
max_*condition. The index will rollover if anymax_*condition is satisfied and allmin_*conditions are satisfied. -
mappingsobject -
Mapping for fields in the index. If specified, this mapping can include field names, field data types, and mapping paramaters.
-
propertiesmap string to oneOf -
<string>union oneOf -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
dimsnumber -
Number of vector dimensions. Can't exceed
4096. Ifdimsis not specified, it will be set to the length of the first vector added to the field. -
element_typeenum · default: float -
The data type used to encode vectors. The supported data types are
float(default),byte, andbit.Supported values include:
bit: Indexes a single bit per dimension. Useful for very high-dimensional vectors or models that specifically support bit vectors.
Notewhen using
bit, the number of dimensions must be a multiple of8and must represent the number of bits.byte: Indexes a 1-byte integer value per dimension.float: Indexes a 4-byte floating-point value per dimension.bfloat16: Indexes a 2-byte floating-point value per dimension.
-
Values:
bitbytefloatbfloat16 -
index_optionsobject -
An optional section that configures the kNN indexing algorithm. The HNSW algorithm has two internal parameters that influence how the data structure is built. These can be adjusted to improve the accuracy of results, at the expense of slower indexing speed.
This parameter can only be specified when
indexistrue. -
confidence_intervalnumberdeprecated -
The confidence interval to use when quantizing the vectors. Can be any value between and including
0.90and1.0or exactly0. When the value is0, this indicates that dynamic quantiles should be calculated for optimized quantization. When between0.90and1.0, this value restricts the values used when calculating the quantization thresholds.For example, a value of
0.95will only use the middle95%of the values when calculating the quantization thresholds (e.g. the highest and lowest2.5%of values will be ignored).Defaults to
1/(dims + 1)forint8quantized vectors and0forint4for dynamic quantile calculation.Only applicable to
int8_hnsw,int4_hnsw,int8_flat, andint4_flatindex types. -
ef_constructionnumber · default: 100 -
The number of candidates to track while assembling the list of nearest neighbors for each new node.
Only applicable to
hnsw,int8_hnsw,bbq_hnsw, andint4_hnswindex types. -
mnumber · default: 16 -
The number of neighbors each node will be connected to in the HNSW graph.
Only applicable to
hnsw,int8_hnsw,bbq_hnsw, andint4_hnswindex types. -
typeenumrequired -
The type of kNN algorithm to use.
Supported values include:
bbq_flat: This utilizes a brute-force search algorithm in addition to automatically quantizing to binary vectors. Only supportselement_typeoffloat.bbq_hnsw: This utilizes the HNSW algorithm in addition to automatic binary quantization for scalable approximate kNN search withelement_typeoffloat.
This can reduce the memory footprint by nearly 32x at the cost of some accuracy.
bbq_disk: This utilizes the DiskBBQ algorithm, a version of Inverted Vector File (IVF) that uses BBQ to quantize vectors. Only supportselement_typeoffloat.
This not only significantly reduces memory usage, but also allows for indexing and searching of very large datasets that do not fit in memory. Unlike HNSW, this index type loses performance gracefully as the index grows larger than memory.
flat: This utilizes a brute-force search algorithm for exact kNN search. This supports allelement_typevalues.hnsw: This utilizes the HNSW algorithm for scalable approximate kNN search. This supports allelement_typevalues.int4_flat: This utilizes a brute-force search algorithm in addition to automatically half-byte scalar quantization. Only supportselement_typeoffloat.int4_hnsw: This utilizes the HNSW algorithm in addition to automatically scalar quantization for scalable approximate kNN search withelement_typeoffloat.
This can reduce the memory footprint by 8x at the cost of some accuracy.
int8_flat: This utilizes a brute-force search algorithm in addition to automatically scalar quantization. Only supportselement_typeoffloat.int8_hnsw: The default index type forfloatvectors. This utilizes the HNSW algorithm in addition to automatically scalar quantization for scalable approximate kNN search withelement_typeoffloat.
This can reduce the memory footprint by 4x at the cost of some accuracy.
-
Values:
bbq_flatbbq_hnswbbq_diskflathnswint4_flatint4_hnswint8_flatint8_hnsw -
rescore_vectorobject -
The rescore vector options. This is only applicable to
bbq_disk,bbq_hnsw,int4_hnsw,int8_hnsw,bbq_flat,int4_flat, andint8_flatindex types. -
oversamplenumberrequired -
The oversampling factor to use when searching for the nearest neighbor. This is only applicable to the quantized formats:
bbq_*,int4_*, andint8_*. When provided,oversample * kvectors will be gathered and then their scores will be re-computed with the original vectors.valid values are between
1.0and10.0(inclusive), or0exactly to disable oversampling. -
on_disk_rescoreboolean · default: false -
trueif vector rescoring should be done on-diskOnly applicable to
bbq_disk,bbq_hnsw,int4_hnsw,int8_hnsw -
flat_index_thresholdnumber · default: -1 -
The segment document count threshold below which HNSW graph construction is skipped in favor of brute-force flat search.
-1(default) defers to format defaults:300forbbq_hnsw,150forhnsw,int8_hnsw, andint4_hnsw.0always builds the graph. A positive value overrides the format default.Only applicable to
hnsw,int8_hnsw,int4_hnsw,bbq_hnsw, andbbq_diskindex types. -
cluster_sizenumber · default: 384 -
Only applicable to
bbq_disk. The number of vectors per cluster. Must be between 64 and 65536. -
default_visit_percentagenumber · default: 0 -
Only applicable to
bbq_disk. The percentage of clusters to visit during search. Must be between 0 and 100. A value of 0 defaults to usingnum_candidatesfor calculating the visit percentage. -
bitsnumber · default: 1 -
Only applicable to
bbq_disk. The number of bits per dimension for quantization encoding. Valid values are1,2,4, or7. When norescore_vectoris explicitly set, the default oversampling is automatically adjusted based on the bits value. This setting can be changed without reindexing. -
preconditionboolean · default: false -
Only applicable to
bbq_disk. Whentrue, transforms indexed vectors using a random orthogonal projection before quantization, which can improve accuracy when vector components are not normally distributed. Cannot be changed after the field is created. -
auto_calibrateboolean · default: false -
Only applicable to
bbq_disk. Whentrue, Elasticsearch automatically selects the optimal quantization encoding, oversampling factor, and preconditioning for each merged segment based on estimated recall characteristics. Cannot be changed after the field is created. -
similarityenum -
The vector similarity metric to use in kNN search.
Documents are ranked by their vector field's similarity to the query vector. The
_scoreof each document will be derived from the similarity, in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.Defaults to
l2_normwhenelement_typeisbitotherwise defaults tocosine.bitvectors only supportl2_normas their similarity metric.This parameter can only be specified when
indexistrue.Supported values include:
cosine: Computes the cosine similarity. During indexing Elasticsearch automatically normalizes vectors withcosinesimilarity to unit length. This allows to internally usedot_productfor computing similarity, which is more efficient. Original un-normalized vectors can be still accessed through scripts.
The document
_scoreis computed as(1 + cosine(query, vector)) / 2.The
cosinesimilarity does not allow vectors with zero magnitude, since cosine is not defined in this case.dot_product: Computes the dot product of two unit vectors. This option provides an optimized way to perform cosine similarity. The constraints and computed score are defined byelement_type.
When
element_typeisfloat, all vectors must be unit length, including both document and query vectors.The document
_scoreis computed as(1 + dot_product(query, vector)) / 2.When
element_typeisbyte, all vectors must have the same length including both document and query vectors or results will be inaccurate.The document
_scoreis computed as0.5 + (dot_product(query, vector) / (32768 * dims))wheredimsis the number of dimensions per vector.l2_norm: Computes similarity based on theL2distance (also known as Euclidean distance) between the vectors.
The document
_scoreis computed as1 / (1 + l2_norm(query, vector)^2).For
bitvectors, instead of usingl2_norm, thehammingdistance between the vectors is used.The
_scoretransformation is(numBits - hamming(a, b)) / numBits.max_inner_product: Computes the maximum inner product of two vectors. This is similar todot_product, but doesn't require vectors to be normalized. This means that each vector’s magnitude can significantly effect the score.
The document
_scoreis adjusted to prevent negative values. Formax_inner_productvalues< 0, the_scoreis1 / (1 + -1 * max_inner_product(query, vector)). For non-negativemax_inner_productresults the_scoreis calculatedmax_inner_product(query, vector) + 1. -
Values:
cosinedot_productl2_normmax_inner_product -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
inference_idstring · default: .jina-embeddings-v5-text-small -
Inference endpoint that will be used to generate embeddings for the field. This parameter cannot be updated. Use the Create inference API to create the endpoint. If
search_inference_idis specified, the inference endpoint will only be used at index time. If theinference_idis not specified, it will default to.jina-embeddings-v5-text-smallif the cluster is authorized to use the Elastic Inference Service, otherwise it will default to.elser-2-elasticsearch. The.elser-2-elasticsearchinference endpoint relies on a local ML node to run the ELSER model. -
search_inference_idstring -
Inference endpoint that will be used to generate embeddings at query time. You can update this parameter by using the Update mapping API. Use the Create inference API to create the endpoint. If not specified, the inference endpoint defined by inference_id will be used at both index and query time.
-
index_optionsobject -
Settings for index_options that override any defaults used by semantic_text, for example specific quantization settings.
-
dense_vectorobject -
Same fields as
index_optionsintype: dense_vector -
sparse_vectorobject -
pruneboolean -
Whether to perform pruning, omitting the non-significant tokens from the query to improve query performance. If prune is true but the pruning_config is not specified, pruning will occur but default values will be used. Default: false
-
pruning_configobject -
Optional pruning configuration. If enabled, this will omit non-significant tokens from the query in order to improve query performance. This is only used if prune is set to true. If prune is set to true but pruning_config is not specified, default values will be used.
-
chunking_settingsunion oneOfnullable -
Settings for chunking text into smaller passages. If specified, these will override the chunking settings sent in the inference endpoint associated with inference_id. If chunking settings are updated, they will not be applied to existing documents until they are reindexed.
- One of:
-
strategystring · default: sentencerequired -
The chunking strategy:
sentence,word,noneorrecursive.- If
strategyis set torecursive, you must also specify:
max_chunk_size- either
separatorsorseparator_group
Learn more about different chunking strategies in the linked documentation.
- If
- Reference
-
max_chunk_sizenumber · default: 250required -
The maximum size of a chunk in words. This value cannot be lower than
20(forsentencestrategy) or10(forwordstrategy). This value should not exceed the window size for the associated model. -
overlapnumber · default: 100 -
The number of overlapping words for chunks. It is applicable only to a
wordchunking strategy. This value cannot be higher than half themax_chunk_sizevalue. -
sentence_overlapnumber · default: 1 -
The number of overlapping sentences for chunks. It is applicable only for a
sentencechunking strategy. It can be either1or0. -
separator_groupstring -
Only applicable to the
recursivestrategy and required when using it.Sets a predefined list of separators in the saved chunking settings based on the selected text type. Values can be
markdownorplaintext.Using this parameter is an alternative to manually specifying a custom
separatorslist. -
separatorsstring[] -
Only applicable to the
recursivestrategy and required when using it.A list of strings used as possible split points when chunking text.
Each string can be a plain string or a regular expression (regex) pattern. The system tries each separator in order to split the text, starting from the first item in the list.
After splitting, it attempts to recombine smaller pieces into larger chunks that stay within the
max_chunk_sizelimit, to reduce the total number of chunks generated. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
index_optionsobject -
Additional index options for the sparse vector field that controls the token pruning behavior of the sparse vector field.
-
pruneboolean -
Whether to perform pruning, omitting the non-significant tokens from the query to improve query performance. If prune is true but the pruning_config is not specified, pruning will occur but default values will be used. Default: false
-
pruning_configobject -
Optional pruning configuration. If enabled, this will omit non-significant tokens from the query in order to improve query performance. This is only used if prune is set to true. If prune is set to true but pruning_config is not specified, default values will be used.
-
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
time_series_metricenum -
For internal use by Elastic only. Marks the field as a time series dimension. Defaults to false.
-
Values:
gaugecountersummaryhistogramposition -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active. -
synthetic_source_keepenum -
Supported values include:
none: Synthetic source diverges from the original source (default)arrays: Arrays of the corresponding field or object preserve the original element ordering and duplicate elements. The synthetic source fragment for such arrays is not guaranteed to match the original source exactly, e.g. array [1, 2, [5], [[4, [3]]], 5] may appear as-is or in an equivalent format like [1, 2, 5, 4, 3, 5]. The exact format may change in the future, in an effort to reduce the storage overhead of this option.all: The source for both singleton instances and arrays of the corresponding field or object gets recorded. When applied to objects, the source of all sub-objects and sub-fields gets captured. Furthermore, the original source of arrays gets captured and appears in synthetic source with no modifications.
-
Values:
nonearraysall -
doc_valuesunion oneOf - One of:
-
multi_valueboolean · default: true -
If
false, the field is treated as single-valued, enabling optimized storage. Only has an effect when columnar index mode is active. -
nullabilityboolean · default: true -
If
false, every document must provide a non-null value for the field: a document that omits the field, sets it tonull, or supplies only null values (an empty array or an all-null array) is rejected at index time. A field that definesnull_valueis always exempt, since the configured default removes the absence of a value. Only has an effect when columnar index mode is active.
type: binary
Configuration object for doc values when sub-parameters are needed.
type: boolean
Configuration object for doc values when sub-parameters are needed.
type: {dynamic_type}
Configuration object for doc values when sub-parameters are needed.
type: join
type: keyword
Configuration object for doc values when sub-parameters are needed.
type: match_only_text
A variant of text that trades scoring and efficiency of positional queries for space efficiency. This field effectively stores data the same way as a text field that only indexes documents (index_options: docs) and disables norms (norms: false). Term queries perform as fast if not faster as on text fields, however queries that need positions such as the match_phrase query perform slower as they need to look at the _source document to verify whether a phrase matches. All queries return constant scores that are equal to 1.0.
type: percolator
type: rank_feature
type: rank_features
type: search_as_you_type
type: text
type: version
Configuration object for doc values when sub-parameters are needed.
type: wildcard
Configuration object for doc values when sub-parameters are needed.
type: date_nanos
Configuration object for doc values when sub-parameters are needed.
type: date
Configuration object for doc values when sub-parameters are needed.
type: aggregate_metric_double
type: dense_vector
type: flattened
type: nested
type: object
type: passthrough
type: rank_vectors
Technical preview
type: semantic_text
type: sparse_vector
type: completion
Configuration object for doc values when sub-parameters are needed.
type: constant_keyword
type: counted_keyword
type: alias
type: histogram
type: exponential_histogram
type: ip
Configuration object for doc values when sub-parameters are needed.
type: murmur3
Configuration object for doc values when sub-parameters are needed.
type: token_count
Configuration object for doc values when sub-parameters are needed.
type: geo_point
Configuration object for doc values when sub-parameters are needed.
type: geo_shape
The geo_shape data type facilitates the indexing of and searching with arbitrary geo shapes such as rectangles
and polygons.
Configuration object for doc values when sub-parameters are needed.
type: point
Configuration object for doc values when sub-parameters are needed.
type: shape
The shape data type facilitates the indexing of and searching with arbitrary x, y cartesian shapes such as
rectangles and polygons.
Configuration object for doc values when sub-parameters are needed.
type: byte
Configuration object for doc values when sub-parameters are needed.
type: double
Configuration object for doc values when sub-parameters are needed.
type: float
Configuration object for doc values when sub-parameters are needed.
type: half_float
Configuration object for doc values when sub-parameters are needed.
type: integer
Configuration object for doc values when sub-parameters are needed.
type: long
Configuration object for doc values when sub-parameters are needed.
type: scaled_float
Configuration object for doc values when sub-parameters are needed.
type: short
Configuration object for doc values when sub-parameters are needed.
type: unsigned_long
Configuration object for doc values when sub-parameters are needed.
type: date_range
Configuration object for doc values when sub-parameters are needed.
type: double_range
Configuration object for doc values when sub-parameters are needed.
type: float_range
Configuration object for doc values when sub-parameters are needed.
type: integer_range
Configuration object for doc values when sub-parameters are needed.
type: ip_range
Configuration object for doc values when sub-parameters are needed.
type: long_range
Configuration object for doc values when sub-parameters are needed.
type: icu_collation_keyword
Configuration object for doc values when sub-parameters are needed.